diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run.sh b/platform/linux-generic/test/validation/api/pktio/pktio_run.sh
index 5b861bbbf..76c12b901 100755
--- a/platform/linux-generic/test/validation/api/pktio/pktio_run.sh
+++ b/platform/linux-generic/test/validation/api/pktio/pktio_run.sh
@@ -21,9 +21,9 @@
 # -in the validation when running standalone (./pktio_run) intree.
 # -in the current directory.
 # running stand alone out of tree requires setting PATH
-PATH=${TEST_DIR}/api/pktio:$PATH
+PATH=${TEST_DIR}/api:$PATH
 PATH=$(dirname $0):$PATH
-PATH=$(dirname $0)/../../../../../../test/validation/api/pktio:$PATH
+PATH=$(dirname $0)/../../../../../../test/validation/api:$PATH
 PATH=.:$PATH
 
 pktio_main_path=$(which pktio_main${EXEEXT})
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run_dpdk.sh b/platform/linux-generic/test/validation/api/pktio/pktio_run_dpdk.sh
index 24194cbc9..730cdbca1 100755
--- a/platform/linux-generic/test/validation/api/pktio/pktio_run_dpdk.sh
+++ b/platform/linux-generic/test/validation/api/pktio/pktio_run_dpdk.sh
@@ -21,9 +21,9 @@
 # -in the validation when running standalone (./pktio_run) intree.
 # -in the current directory.
 # running stand alone out of tree requires setting PATH
-PATH=${TEST_DIR}/api/pktio:$PATH
+PATH=${TEST_DIR}/api:$PATH
 PATH=$(dirname $0):$PATH
-PATH=$(dirname $0)/../../../../../../test/validation/api/pktio:$PATH
+PATH=$(dirname $0)/../../../../../../test/validation/api:$PATH
 PATH=.:$PATH
 
 pktio_main_path=$(which pktio_main${EXEEXT})
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run_netmap.sh b/platform/linux-generic/test/validation/api/pktio/pktio_run_netmap.sh
index 610be3bdc..e0a19caea 100755
--- a/platform/linux-generic/test/validation/api/pktio/pktio_run_netmap.sh
+++ b/platform/linux-generic/test/validation/api/pktio/pktio_run_netmap.sh
@@ -15,9 +15,9 @@
 # -in the validation when running standalone (./pktio_run) intree.
 # -in the current directory.
 # running stand alone out of tree requires setting PATH
-PATH=${TEST_DIR}/api/pktio:$PATH
+PATH=${TEST_DIR}/api:$PATH
 PATH=$(dirname $0):$PATH
-PATH=$(dirname $0)/../../../../../../test/validation/api/pktio:$PATH
+PATH=$(dirname $0)/../../../../../../test/validation/api:$PATH
 PATH=.:$PATH
 
 pktio_main_path=$(which pktio_main${EXEEXT})
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run_pcap.sh b/platform/linux-generic/test/validation/api/pktio/pktio_run_pcap.sh
index 5ab45094a..247854796 100755
--- a/platform/linux-generic/test/validation/api/pktio/pktio_run_pcap.sh
+++ b/platform/linux-generic/test/validation/api/pktio/pktio_run_pcap.sh
@@ -15,9 +15,9 @@
 # -in the validation when running standalone intree.
 # -in the current directory.
 # running stand alone out of tree requires setting PATH
-PATH=${TEST_DIR}/api/pktio:$PATH
+PATH=${TEST_DIR}/api:$PATH
 PATH=$(dirname $0):$PATH
-PATH=$(dirname $0)/../../../../../../test/validation/api/pktio:$PATH
+PATH=$(dirname $0)/../../../../../../test/validation/api:$PATH
 PATH=.:$PATH
 
 pktio_main_path=$(which pktio_main${EXEEXT})
diff --git a/test/m4/configure.m4 b/test/m4/configure.m4
index 18c71d799..52e9317d5 100644
--- a/test/m4/configure.m4
+++ b/test/m4/configure.m4
@@ -7,5 +7,4 @@ AC_CONFIG_FILES([test/Makefile
 		 test/miscellaneous/Makefile
 		 test/performance/Makefile
 		 test/validation/Makefile
-		 test/validation/api/Makefile
-		 test/validation/api/pktio/Makefile])
+		 test/validation/api/Makefile])
diff --git a/test/validation/api/.gitignore b/test/validation/api/.gitignore
index f6bf6e54b..50a76a3b9 100644
--- a/test/validation/api/.gitignore
+++ b/test/validation/api/.gitignore
@@ -20,6 +20,7 @@ ipsec_inline_out
 ipsec_sync
 lock_main
 packet_main
+pktio_main
 pool_main
 queue_main
 random_main
diff --git a/test/validation/api/Makefile.am b/test/validation/api/Makefile.am
index b45828c54..48a78c16e 100644
--- a/test/validation/api/Makefile.am
+++ b/test/validation/api/Makefile.am
@@ -1,6 +1,3 @@
-ODP_MODULES = \
-	      pktio
-
 SUBDIRS = $(ODP_MODULES)
 
 include Makefile.inc
@@ -25,6 +22,7 @@ test_PROGRAMS = \
 		ipsec_sync \
 		lock_main \
 		packet_main \
+		pktio_main \
 		pool_main \
 		queue_main \
 		random_main \
@@ -68,6 +66,7 @@ ipsec_inline_out_SOURCES = ipsec_inline_out.c
 ipsec_inline_out_LDADD = $(LDADD) libtestipsec.la
 lock_main_SOURCES = lock.c
 packet_main_SOURCES = packet.c
+pktio_main_SOURCES = pktio.c pktio_parser.c pktio_parser.h
 pool_main_SOURCES = pool.c
 queue_main_SOURCES = queue.c
 random_main_SOURCES = random.c
diff --git a/test/validation/api/pktio/pktio.c b/test/validation/api/pktio.c
similarity index 99%
rename from test/validation/api/pktio/pktio.c
rename to test/validation/api/pktio.c
index a0496642f..3516d6f4a 100644
--- a/test/validation/api/pktio/pktio.c
+++ b/test/validation/api/pktio.c
@@ -12,7 +12,7 @@
 #include <odp/helper/odph_api.h>
 
 #include <stdlib.h>
-#include "parser.h"
+#include "pktio_parser.h"
 
 #define PKT_BUF_NUM            32
 #define PKT_BUF_SIZE           (9 * 1024)
diff --git a/test/validation/api/pktio/.gitignore b/test/validation/api/pktio/.gitignore
deleted file mode 100644
index 1a5dd46e4..000000000
--- a/test/validation/api/pktio/.gitignore
+++ /dev/null
@@ -1 +0,0 @@
-pktio_main
diff --git a/test/validation/api/pktio/Makefile.am b/test/validation/api/pktio/Makefile.am
deleted file mode 100644
index ffd1827be..000000000
--- a/test/validation/api/pktio/Makefile.am
+++ /dev/null
@@ -1,4 +0,0 @@
-include ../Makefile.inc
-
-test_PROGRAMS = pktio_main
-pktio_main_SOURCES = pktio.c parser.c parser.h
diff --git a/test/validation/api/pktio/parser.c b/test/validation/api/pktio_parser.c
similarity index 99%
rename from test/validation/api/pktio/parser.c
rename to test/validation/api/pktio_parser.c
index e0431441f..a998981e0 100644
--- a/test/validation/api/pktio/parser.c
+++ b/test/validation/api/pktio_parser.c
@@ -13,7 +13,7 @@
 #include <odp/helper/odph_api.h>
 
 #include <stdlib.h>
-#include "parser.h"
+#include "pktio_parser.h"
 
 #define MAX_NUM_IFACES         2
 #define PKT_POOL_NUM           256
diff --git a/test/validation/api/pktio/parser.h b/test/validation/api/pktio_parser.h
similarity index 100%
rename from test/validation/api/pktio/parser.h
rename to test/validation/api/pktio_parser.h