diff --git a/platform/linux-generic/m4/configure.m4 b/platform/linux-generic/m4/configure.m4
index 7fa3652e2..544a02861 100644
--- a/platform/linux-generic/m4/configure.m4
+++ b/platform/linux-generic/m4/configure.m4
@@ -20,7 +20,7 @@ AC_CONFIG_FILES([platform/linux-generic/Makefile
 		 platform/linux-generic/libodp-linux.pc
 		 platform/linux-generic/test/Makefile
 		 platform/linux-generic/test/validation/api/shmem/Makefile
-		 platform/linux-generic/test/validation/api/pktio/Makefile
+		 platform/linux-generic/test/validation/api/Makefile
 		 platform/linux-generic/test/mmap_vlan_ins/Makefile
 		 platform/linux-generic/test/pktio_ipc/Makefile
 		 platform/linux-generic/test/ring/Makefile
diff --git a/platform/linux-generic/test/Makefile.am b/platform/linux-generic/test/Makefile.am
index 99934099a..06c06c7e8 100644
--- a/platform/linux-generic/test/Makefile.am
+++ b/platform/linux-generic/test/Makefile.am
@@ -4,35 +4,31 @@ TESTS_ENVIRONMENT += TEST_DIR=${top_builddir}/test/validation
 SUBDIRS = performance
 
 if test_vald
-TESTS = validation/api/pktio/pktio_run.sh \
-	validation/api/pktio/pktio_run_tap.sh \
+TESTS = validation/api/pktio_run.sh \
+	validation/api/pktio_run_tap.sh \
 	validation/api/shmem/shmem_linux$(EXEEXT)
 
-SUBDIRS += validation/api/pktio\
+SUBDIRS += validation/api\
 	   validation/api/shmem\
 	   mmap_vlan_ins\
 	   pktio_ipc\
 	   ring
 
 if HAVE_PCAP
-TESTS += validation/api/pktio/pktio_run_pcap.sh
+TESTS += validation/api/pktio_run_pcap.sh
 
 TESTS +=   mmap_vlan_ins/mmap_vlan_ins.sh
 SUBDIRS += mmap_vlan_ins
 endif
 if netmap_support
-TESTS += validation/api/pktio/pktio_run_netmap.sh
+TESTS += validation/api/pktio_run_netmap.sh
 endif
 if PKTIO_DPDK
-TESTS += validation/api/pktio/pktio_run_dpdk.sh
+TESTS += validation/api/pktio_run_dpdk.sh
 endif
 TESTS += pktio_ipc/pktio_ipc_run.sh
 SUBDIRS += pktio_ipc
 else
-#performance tests refer to pktio_env
-if test_perf
-SUBDIRS += validation/api/pktio
-endif
 endif
 
 TEST_EXTENSIONS = .sh
diff --git a/platform/linux-generic/test/validation/api/pktio/Makefile.am b/platform/linux-generic/test/validation/api/Makefile.am
similarity index 100%
rename from platform/linux-generic/test/validation/api/pktio/Makefile.am
rename to platform/linux-generic/test/validation/api/Makefile.am
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_env b/platform/linux-generic/test/validation/api/pktio_env
similarity index 100%
rename from platform/linux-generic/test/validation/api/pktio/pktio_env
rename to platform/linux-generic/test/validation/api/pktio_env
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run.sh b/platform/linux-generic/test/validation/api/pktio_run.sh
similarity index 100%
rename from platform/linux-generic/test/validation/api/pktio/pktio_run.sh
rename to platform/linux-generic/test/validation/api/pktio_run.sh
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run_dpdk.sh b/platform/linux-generic/test/validation/api/pktio_run_dpdk.sh
similarity index 100%
rename from platform/linux-generic/test/validation/api/pktio/pktio_run_dpdk.sh
rename to platform/linux-generic/test/validation/api/pktio_run_dpdk.sh
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run_netmap.sh b/platform/linux-generic/test/validation/api/pktio_run_netmap.sh
similarity index 100%
rename from platform/linux-generic/test/validation/api/pktio/pktio_run_netmap.sh
rename to platform/linux-generic/test/validation/api/pktio_run_netmap.sh
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run_pcap.sh b/platform/linux-generic/test/validation/api/pktio_run_pcap.sh
similarity index 100%
rename from platform/linux-generic/test/validation/api/pktio/pktio_run_pcap.sh
rename to platform/linux-generic/test/validation/api/pktio_run_pcap.sh
diff --git a/platform/linux-generic/test/validation/api/pktio/pktio_run_tap.sh b/platform/linux-generic/test/validation/api/pktio_run_tap.sh
similarity index 100%
rename from platform/linux-generic/test/validation/api/pktio/pktio_run_tap.sh
rename to platform/linux-generic/test/validation/api/pktio_run_tap.sh
diff --git a/test/performance/odp_l2fwd_run.sh b/test/performance/odp_l2fwd_run.sh
index 0cb293dc8..96930f6c6 100755
--- a/test/performance/odp_l2fwd_run.sh
+++ b/test/performance/odp_l2fwd_run.sh
@@ -42,8 +42,8 @@ elif  [ "$ODP_PLATFORM" = "" ]; then
 	echo "$0: error: ODP_PLATFORM must be defined"
 	# not skipped as this should never happen via "make check"
 	exit 1
-elif [ -f ${PLATFORM_VALIDATION}/api/pktio/pktio_env ]; then
-	. ${PLATFORM_VALIDATION}/api/pktio/pktio_env
+elif [ -f ${PLATFORM_VALIDATION}/api/pktio_env ]; then
+	. ${PLATFORM_VALIDATION}/api/pktio_env
 else
 	echo "BUG: unable to find pktio_env!"
 	echo "pktio_env has to be in current directory or in platform/\$ODP_PLATFORM/test."